<style>
	.input{
		margin: 1em;
		padding: 0.3em;
		border-radius: 0.3em;
		border: 1px solid #555;
		outline: none;
		flex: 1 1 auto;
		background-color: #222;
		color: #FFF;
		word-wrap: break-word;
	}
	span{
		white-space: pre-wrap;
	}
	.highlighted{
		background-color: #555;
	}
</style>
<script>
	import Text from './text'

	export let selectedIndex = 0
	export let text = 'Ma-i-a hi Ma-i-a hu Ma-i-a ho Ma-i-a ha-ha Ma-i-a hi Ma-i-a hu Ma-i-a ho Ma-i-a ha-ha Ma-i-a hi Ma-i-a hu Ma-i-a ho Ma-i-a ha-ha Ma-i-a hi Ma-i-a hu Ma-i-a ho Ma-i-a ha-ha Alo, salut, sunt eu, un haiduc Și te rog, iubirea mea, primește fericirea Alo, alo, sunt eu Picasso Ți-am dat beep, și sunt voinic Dar sa știi, nu-ți cer nimic Vrei să pleci dar nu mă, nu mă iei Nu mă, nu mă iei, nu mă, nu mă, nu mă iei Chipul tău și dragostea din tei Mi-amintesc de ochii tăi Vrei sa pleci dar nu mă, nu mă iei Nu mă, nu mă iei, nu mă, nu mă, nu mă iei Chipul tău și dragostea din tei Mi-amintesc de ochii tăi Te sun, să-ți spun, ce simt acum Alo, iubirea mea, sunt eu, fericirea Alo, alo, sunt iarăși eu, Picasso Ți-am dat beep, și sunt voinic Dar sa știi, nu-ți cer nimic Vrei să pleci dar nu mă, nu mă iei Nu mă, nu mă iei, nu mă, nu mă, nu mă iei Chipul tău și dragostea din tei Mi-amintesc de ochii tăi Vrei sa pleci dar nu mă, nu mă iei Nu mă, nu mă iei, nu mă, nu mă, nu mă iei Chipul tău și dragostea din tei Mi-amintesc de ochii tăi Ma-i-a hi Ma-i-a hu Ma-i-a ho Ma-i-a ha-ha Ma-i-a hi Ma-i-a hu Ma-i-a ho Ma-i-a ha-ha Ma-i-a hi Ma-i-a hu Ma-i-a ho Ma-i-a ha-ha Ma-i-a hi Ma-i-a hu Ma-i-a ho Ma-i-a ha-ha Vrei să pleci dar nu mă, nu mă iei Nu mă, nu mă iei, nu mă, nu mă, nu mă iei Chipul tău și dragostea din tei Mi-amintesc de ochii tăi Vrei să pleci dar nu mă, nu mă iei Nu mă, nu mă iei, nu mă, nu mă, nu mă iei Chipul tău și dragostea din tei Mi-amintesc de ochii tăi'
	export let tokens = []
	$: tokens = text.split(/(?=\s+)|(?=\b\S+)/g)

	let selected = false

	export const current = ()=> tokens[selectedIndex]
	export const next = ()=>{
		selectedIndex++
		if(selectedIndex>=tokens.length){
			selectedIndex = 0
		}else return tokens[selectedIndex]
	}
</script>
{#if selected}
	<Text bind:value={text} on:focusout={e=>{
		selected=false
		const selectionIndex = e.target.selectionStart
		if(selectionIndex !== undefined && selectionIndex < text.length){
			let pos = 0
			for(const i in tokens){
				const token = tokens[i]
				pos += token.length
				if(pos > selectionIndex){
					selectedIndex = i
					break
				}
			}
		}else selectedIndex = 0
	}}/>
{:else}
	<div class='input' on:click={()=>{
		selected=true
	}}>
		{#each tokens as token, index (index)}
			<span class:highlighted={selectedIndex==index}>{token}</span>
		{/each}
	</div>
{/if}
